Subject: bug#42569: 'No such file or directory builder' error while building with qemu-binfmt and --system=aarch64-linux

From: Maxim Cournoyer <[email-masked]>
Date: Tue, 28 Jul 2020 09:37:53 -0400

Hello Mathieu!

Mathieu Othacehe <[email-masked]> writes:

> Hello Maxim,
>
>> The following derivation will be built:
>>    /gnu/store/vs11h35gq7fi90bm0h4ygi7ak4ihkck8-lib2geom-1.0-1.42e119d.drv
>> building /gnu/store/vs11h35gq7fi90bm0h4ygi7ak4ihkck8-lib2geom-1.0-1.42e119d.drv...
>> while setting up the build environment: executing
>> `/gnu/store/x3gq648qnfnla7nppyfjvj62s2i8y7rl-guile-3.0.2/bin/guile':
>> No such file or directory
>> builder for `/gnu/store/vs11h35gq7fi90bm0h4ygi7ak4ihkck8-lib2geom-1.0-1.42e119d.drv' failed with exit code 1
>> build of /gnu/store/vs11h35gq7fi90bm0h4ygi7ak4ihkck8-lib2geom-1.0-1.42e119d.drv failed
>> View build log at '/var/log/guix/drvs/vs/11h35gq7fi90bm0h4ygi7ak4ihkck8-lib2geom-1.0-1.42e119d.drv.bz2'.
>> guix build: error: build of
>>    `/gnu/store/vs11h35gq7fi90bm0h4ygi7ak4ihkck8-lib2geom-1.0-1.42e119d.drv' failed

> This reminds me an issue I had running qemu-binfmt based builds on a
> foreign distribution. From what I understand you are offloading builds
> to a Guix System machine, but is the machine displaying the above
> message also running Guix System?

I thought I was offloading, but as I wrote in a follow-up message, there
was no offloading involved and the problem was strictly local
(restarting the local qemu-binfmt service fixed it).

> If that's not the case, there are some tricks to make it run, that I'm
> supposed to document, see:
> https://lists.gnu.org/archive/html/guix-devel/2019-11/msg00423.html.

Interesting :-). I pondered about such feasibility in the past, good to
know that it *can* work (with some fiddling :-). I think it'd be neat to
have this documented.

Thank you!

Maxim